﻿/************************ 
Copyright Notice This objects content is copyright of Dynamic Manufacturing Solutions Inc 2011. 
All rights reserved. 
Any redistribution or reproduction of part or all of the contents in any form is prohibited. 
************************/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using System.Data.Entity;
using System.Data.Entity.ModelConfiguration;
using System.ComponentModel.DataAnnotations;


namespace DMS.Examples.NavData.Web.Models
{
    /// <summary>
    /// 
    /// The models and their relationships should be mapped here.
    /// 
    /// 
    /// </summary>
    public class ExamplesDataContext : DMS.NavHelpers.DynamicsNavDataContext 
    {
        public static ExamplesDataContext BuildContext()
        {
            DbModelBuilder modelBuilder = new DbModelBuilder(DbModelBuilderVersion.V4_1);
            BuildModel(modelBuilder);
            return new ExamplesDataContext(modelBuilder);
        }

        private static void BuildModel(DbModelBuilder modelBuilder)
        {
            modelBuilder.Configurations.Add(new EntityTypeConfiguration<Contact>());
            modelBuilder.Configurations.Add(new EntityTypeConfiguration<Company>());
            modelBuilder.Entity<Contact>().ToTable(DMS.NavHelpers.DynamicsNavTableAttribute.GetCompanyTableName("Contact"));

            modelBuilder.Entity<Contact>()
                    .HasKey(c => new { c.ContactNo });

            modelBuilder.Entity<Company>()
                .HasKey(c => new { c.Name });

        }

        public ExamplesDataContext(DbModelBuilder modelBuilder)
            : base(modelBuilder)
        {
            // don't write changes back to the database
            Database.SetInitializer<ExamplesDataContext>(null);
        }
        public DbSet<Contact> Contacts { get; set; }
        public DbSet<Company> Companies { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            //
            // OnModelCreating is only called once per app domain.
            //
            
            base.OnModelCreating(modelBuilder);
           
            if (null != modelBuilder)
            {
                BuildModel(modelBuilder);

                
            }

        }

       
    }
}